This implementation of PPP is designed to be as complete as  pos-
sible.   Because  of  this,  the  number of options can be rather
daunting.  However, a typical PPP configuration might include the
following commands:

        ppp quick
        ppp lcp open


3.42.2.  ppp quick

Quick setup for the PPP link.  By popular demand, this command is
a shortcut for the following commands:

        ppp ipcp local compress tcp 16 1
        ppp ipcp open
        ppp lcp local accm 0
        ppp lcp local acfc on
        ppp lcp local pfc on
        ppp lcp local magic on

3.42.3.  ppp lcp ...

These commands are used for the LCP [Link Control Protocol]  con-
figuration.

3.42.3.1.  ppp lcp close

Shutdown the PPP interface.

3.42.3.2.  ppp lcp local ...

These commands control the configuration of the local side of the
link.   If an option is specified, the parameters will be used as
the initial values in configuration requests.  If not  specified,
that option will not be requested.

For each of these options, the allow parameter  will  permit  the
remote  to  include  that  option  in its response, even when the
option is not included in the request.  By default,  all  options
are allowed.

3.42.3.2.1.  ppp lcp local accm [ <bitmap> | allow [on  |
off] ]

Display or set the Async Control Character Map.  The  default  is
0xffffffff.

3.42.3.2.2.  ppp lcp local authenticate [ pap  |  none  |
allow [on | off] ]

Display or set the authentication protocol.  The default is none.

3.42.3.2.3.  ppp lcp local acfc [ on | off | allow [on  |
off] ]

Display or set the option to compress  the  address  and  control
fields  of the PPP HLDC-like header.  This is generally desirable
for slow asynchronous links, and undesirable for fast or synchro-
nous links.  The default is off.

3.42.3.2.4.  ppp lcp local pfc [ on | off | allow  [on  |
off] ]

Display or set the option to compress the protocol field  of  the
PPP HLDC-like header.  This is generally desirable for slow asyn-
chronous links, and undesirable for fast  or  synchronous  links.
The default is off.

3.42.3.2.5.  ppp lcp local magic [ on | off |  <value>  |
allow [on | off] ]

Display or set the initial Magic  Number.   The  default  is  off
(zero).

3.42.3.2.6.  ppp lcp local mru [ <size>  |  allow  [on  |
off] ]

Display or set the Maximum Receive Unit.  The default is 1500.

3.42.3.2.7.  ppp lcp local default

Reset the options to their default values.

3.42.3.3.  ppp lcp listen

Wait for the physical layer to come up, then wait for  configura-
tion negotiation from the remote.  The open command is preferred.

3.42.3.4.  ppp lcp open

Wait for the physical layer to come up, then initiate  configura-
tion negotiation.

3.42.3.5.  ppp lcp remote ...

These commands control the configuration of the  remote  side  of
the  link.  The options are identical to those of the local side.
If an option  is  specified,  the  parameters  will  be  used  in
responses  to the remote's configuration requests.  If not speci-
fied, that option will be accepted if it is allowed.

For each of these options, the allow parameter  will  permit  the
remote  to  specify  that option in its request.  By default, all
options are allowed.

3.42.3.6.  ppp lcp timeout [<seconds>]

Display or set the interval to wait between configuration or ter-
mination attempts.  The default is 3 seconds.

3.42.3.7.  ppp lcp try ...

These commands are used for the various counters.

3.42.3.7.1.  ppp lcp try configure [<count>]

Display or set the number of configuration  requests  sent.   The
default is 20.

3.42.3.7.2.  ppp lcp try failure [<count>]

Display or set the number of bad configuration  requests  allowed
from the remote.  The default is 10.

3.42.3.7.3.  ppp lcp try terminate [<count>]

Display or set the number of  termination  requests  sent  before
shutdown.  The default is 2.

3.42.4.  ppp ipcp ...

These commands are used for the IPCP [Internet  Protocol  Control
Protocol] configuration.

The close, listen, open, timeout and try sub-commands are identi-
cal to the LCP (described above).

3.42.4.1.  ppp ipcp local ...

These commands control the configuration of the local side of the
link.   If an option is specified, the parameters will be used as
the initial values in configuration requests.  If not  specified,
that option will not be requested.

For each of these options, the allow parameter  will  permit  the
remote  to  include  that  option  in its response, even when the
option is not included in the request.  By default,  all  options
are allowed.

3.42.4.1.1.  ppp ipcp local address [  <hostid>  |  allow
[on | off] ]

Display or set the local address for negotiation purposes.  If an
address of 0 is specified, the other side of the link will supply
the address.  By default, no addresses are negotiated.

3.42.4.1.2.  ppp   ipcp  local  compress  [  tcp  <slots>
[<flag>] | none | allow [on | off] ]

Display or set the compression protocol.  The default is none.

The tcp <slots> specifies the  number  of  "conversation"  slots,
which must be 1 to 255.  (This may be limited at compilation time
to a smaller number.) A good choice is in the range 4 to 16.

The tcp <flag> is 0 (don't compress the slot number) or 1 (OK  to
compress  the  slot  number).   KA9Q  can  handle compressed slot
numbers, so the default is 1.

3.42.4.2.  ppp ipcp remote ...

These commands control the configuration of the  remote  side  of
the  link.  The options are identical to those of the local side.
If an option  is  specified,  the  parameters  will  be  used  in
responses  to the remote's configuration requests.  If not speci-
fied, that option will be accepted if it is allowed.

For each of these options, the allow parameter  will  permit  the
remote  to  specify  that option in its request.  By default, all
options are allowed.

3.42.5.  ppp pap ...

These commands are used for the PAP [Password Authentication Pro-
tocol] configuration.

The timeout  and  try  sub-commands  are  identical  to  the  LCP
(described above).  However, the terminate counter is unused.

3.42.5.1.  ppp pap user [ <username> [<password>] ]

Display or set the username (the password may  be  set,  but  not
displayed).   When  the username is specified, but no password is
supplied, the ftpusers file is searched for the password.  When a
username/password  is  unknown or rejected, a session will appear
at the console to prompt for a new username/password.

3.42.6.  ppp trace [<flags>]

Display or set the flags that control the logging of  information
during PPP link configuration.

The flag value is 0 for none, 1 for basic,  and  2  for  general.
Values greater than 2 are usually not compiled, and are described
in the appropriate source files where they are defined.

