VERSION 2.00
Begin Form Setup1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00400000&
   Caption         =   "Test App Setup"
   ClientHeight    =   2130
   ClientLeft      =   1860
   ClientTop       =   2610
   ClientWidth     =   5640
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   FontBold        =   -1  'True
   FontItalic      =   -1  'True
   FontName        =   "MS Sans Serif"
   FontSize        =   24
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   ForeColor       =   &H00000000&
   Height          =   2535
   Icon            =   SETUP1.FRX:0000
   Left            =   1800
   LinkMode        =   1  'Source
   LinkTopic       =   "Form3"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   376
   Top             =   2265
   Width           =   5760
   Begin Label Label2 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "To customize this setup program, modify the FORM_LOAD event procedure in this form."
      Height          =   435
      Left            =   15
      TabIndex        =   1
      Top             =   15
      Visible         =   0   'False
      Width           =   5625
   End
   Begin Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This label used for DDE connection to the Program Manager"
      Height          =   390
      Left            =   15
      TabIndex        =   0
      Top             =   525
      Visible         =   0   'False
      Width           =   5610
   End
End

Const APPNAME = "WinWAIS Version 2.4"
Const APPDIR = "C:\WAIS"    ' The default install directory

' Set the total uncompressed file sizes
' by adding the sizes of the files

Const WINSYSNEEDED = 138240 ' 135 * 1024 Files that go into WINDOWS and SYSTEM directory
Const OTHERNEEDED = 1249280 ' 1220 * 1024 Files that don't go into the WINDOWS or SYSTEM directory

Sub DrawBackground ()
    setup1.CurrentY = 5
    setup1.CurrentX = 5
    setup1.ForeColor = QBColor(15)
    Print APPNAME + " Setup"
End Sub

Sub Form_Load ()
    
    '----------
    ' Initialize
    '----------
    dialogCaption$ = APPNAME + " Setup"
    ShowMainForm dialogCaption$
    
    '----------------------------------------------------
    ' SETUP.EXE passes the source drive in a command
    ' argument.  If it is empty,  that means the user
    ' executed this .exe directly.  In that case, show
    ' a dialog to get the desired source directory.
    '----------------------------------------------------
    SourcePath$ = Command$
    If SourcePath$ = "" Then
        title$ = dialogCaption$
        caption1$ = "Please enter the drive or path containing the " + APPNAME + " source files."
        caption2$ = "Install From:"
        defaultDrive$ = "A:"
        defaultText$ = "A:\"

        ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$

        If outButton$ = "exit" Then GoTo ErrorSetup
    Else
        If Right$(SourcePath$, 1) <> "\" Then
            SourcePath$ = SourcePath$ + "\"
        End If
    End If


    '--------------------
    ' Get Destination Path
    '--------------------
    title$ = dialogCaption$
    caption1$ = "If you want to install WinWAIS in a different directory and/or drive, type the name of the directory."
    caption2$ = "Install To:"
    defaultDrive$ = "C:"
    defaultText$ = APPDIR

    ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, destPath$, outButton$

    If outButton$ = "exit" Then GoTo ErrorSetup
    
    '-----------------------------------------
    ' Dim disk space variables as Long Integers
    '-----------------------------------------
    Dim winSpaceFree As Long
    Dim sourceSpaceFree As Long
    Dim destSpaceFree As Long
    Dim totalNeeded As Long

    winDir$ = GetWindowsDir$()
    winSysDir$ = GetWindowsSysDir$()

    '---------------------------------------------------------
    ' If the Windows \SYSTEM directory is a subdirectory
    ' of the Windows directory, the proper place for
    ' installation of .VBXs and shared .DLLs is the
    ' Windows \SYSTEM directory.
    '
    ' If the Windows \SYSTEM directory is *not* a subdirectory
    ' of the Windows directory, then the user is running a
    ' shared version of Windows, and the proper place for
    ' installation of .VBXs and shared .DLLs is the
    ' Windows directory.
    '---------------------------------------------------------
    
    If InStr(winSysDir$, winDir$) = 0 Then
        winSysDir$ = winDir$
    End If

    '---------------------------------
    ' Get Drive Letters of directories
    '---------------------------------
    
    winDrive$ = UCase$(Left$(winDir$, 1))
    destDrive$ = UCase$(Left$(destPath$, 1))
    sourceDrive$ = UCase$(Left$(SourcePath$, 1))

    '---------------------------------
    ' Compute free disk space variables
    '---------------------------------
    
    winSpaceFree = GetDiskSpaceFree(winDrive$)
    destSpaceFree = GetDiskSpaceFree(destDrive$)
    
    '-----------------------------------------
    ' Check for enough disk space.
    '
    ' Some components are being installed into the
    ' Windows\SYSTEM directory.
    '
    ' So if the main destination path is on a
    ' different drive than the drive with
    ' the Windows \SYSTEM directory, we have to
    ' check both drives.
    '
    ' An example of this is when the user is installing
    ' the main product to drive D:, but the Windows
    ' directory is on drive c:
    ' -----------------------------------------
    
    totalNeeded = WINSYSNEEDED + OTHERNEEDED
    
    If winDrive$ = destDrive$ Then
        If destSpaceFree < totalNeeded Then
            MsgBox "There is not enough disk space on drive " + destDrive$ + ":   An estimated" + Str$(totalNeeded - destSpaceFree) + " additional bytes are needed.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
    Else
        If winSpaceFree < WINSYSNEEDED Then
            MsgBox "There is not enough disk space on drive " + winDrive$ + ":  An estimated" + Str$(WINSYSNEEDED - winSpaceFree) + " additional bytes are needed.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
        If destSpaceFree < OTHERNEEDED Then
            MsgBox "There is not enough disk space on drive " + destDrive$ + ":  An estimated" + Str$(OTHERNEEDED - destSpaceFree) + " additional bytes are needed.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
        
    End If

    '----------------------------
    ' Create destination directory
    '----------------------------
    
    If Not CreatePath(destPath$) Then GoTo ErrorSetup
    
    ShowStatusDialog dialogCaption$, totalNeeded
    
    '-----------
    ' Copy Files
    '-----------

    If Not PromptForNextDisk(1, SourcePath$ + "wais1") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, destPath$, "readme.txt", "readme.txt") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, destPath$, "wais.exe", "wais.exe") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "wais.dll", "wais.dll") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "wais.hlp", "wais.hlp") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "wais.slp", "wais.slp") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "wais.src", "wais.src") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "wais.ver", "wais.ver") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, destPath$, "wdbiidos", "wdbiidos") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, destPath$, "vttelnet.exe", "vttelnet.exe") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, destPath$, "waisdial.exe", "waisdial.exe") Then GoTo ErrorSetup
    
    If Not CopyFile(SourcePath$, winSysDir$, "cmdialog.vbx", "cmdialog.vbx") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, winSysDir$, "spin.vbx", "spin.vbx") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, winSysDir$, "threed.vbx", "threed.vbx") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, winSysDir$, "mscomm.vbx", "mscomm.vbx") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, winSysDir$, "vtsocket.vbx", "vtsocket.vbx") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, winSysDir$, "vtsocket.hlp", "vtsocket.hlp") Then GoTo ErrorSetup
    
    Unload StatusDlg
    ShowStaticMessageDialog dialogCaption$, "Creating Program Manager Icon..."
    CreateProgManGroup setup1, "WinWais 2.4", "WAIS.GRP"
    CreateProgManItem setup1, destPath$ + "WAIS.EXE", "WinWais 2.4"
    CreateProgManItem setup1, destPath$ + "WAISDIAL.EXE", "Wais Dialer"
    
    MessageDlg.Hide
    If MsgBox(APPNAME + " Installation is Complete!  Would you like to review the README file?", 48 + 4, dialogCaption$) = 6 Then
      setup1.Hide
      z = Shell("notepad.exe " + destPath$ + "readme.txt", 1)
      End
    End If


ExitSetup:
    setup1.Hide
    RestoreProgMan         'Show the program manager
    End
    Exit Sub

ErrorSetup:
    MsgBox APPNAME + " is not properly installed.  Please re-run setup at a later time to install the Test Application properly.", 48, dialogCaption$
    End
    Exit Sub
    
End Sub

Sub Form_Paint ()
    DrawBackground
End Sub

'---------------------------------------------------------------
' Sets the form's caption, Paints 3-D Background Text, Shows Form
'---------------------------------------------------------------
Sub ShowMainForm (Caption$)
    Screen.MousePointer = 11
    setup1.Caption = Caption$
    setup1.Move 0, 0, Screen.Width, Screen.Height * .85
    setup1.Show
    setup1.Refresh

    setup1.ScaleMode = 2
    setup1.FontSize = 24
    setup1.FontBold = True
    setup1.FontItalic = True
    
    DrawBackground
End Sub

Sub ShowPathDialog (title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$)
        Screen.MousePointer = 11
        Load PathDlg
        PathDlg.Caption = title$
        PathDlg.Label1.Caption = caption1$
        PathDlg.Label2.Caption = caption2$
        PathDlg.inDrive.Tag = defaultDrive$
        PathDlg.Text1.Text = defaultText$
        PathDlg.Text1.SelStart = 0
        PathDlg.Text1.SelLength = Len(defaultText$)
        CenterForm PathDlg
        Screen.MousePointer = 0

        PathDlg.Show 1
        
        SourcePath$ = PathDlg.outPath.Tag
        outButton$ = PathDlg.outButton.Tag
        Unload PathDlg
End Sub

Sub ShowStaticMessageDialog (title$, Caption$)

    Load MessageDlg
    CenterForm MessageDlg
    MessageDlg.Caption = title$
    MessageDlg.Label.Caption = Caption$
    MessageDlg.Show
    MessageDlg.Refresh

End Sub

Sub ShowStatusDialog (title$, totalBytes As Long)

    Load StatusDlg
    StatusDlg.Caption = title$
    StatusDlg.total.Tag = Str$(totalBytes)
    CenterForm StatusDlg
    StatusDlg.Show

End Sub

