This is patch 5 for the SunOs version of Brad Clements' port of Drew
Perkins' version of PPP.

Patch 4 said that it was patch 3.  Sorry.

Fixes include:

  - ppp.c now properly sets its process group ID, fixing the
    "tcsetpgrp() ..." error of the patch 4 code.  Thanks to Greg
    Onufer <greg@cheers.Bungi.COM>.

  - README now says to ignore it and use Readme.streams instead.

  - Several debug messages that went to stdout now go to stderr.

  - VJ TCP header compression negotiation is now done correctly.  The
    old (wrong) behavior can be gotten by putting "old" on the command
    line.

  - INSTALL/chat.c upgraded lots.

  - INSTALL/ppp-on changed to not use xlogout.

  - INSTALL/* changed to use /usr/spool/locks.

To patch:

    patch -p0 < this-file

If you have any problems, write to me or post to the newsgroup
comp.protocols.ppp.

Karl Fox <karl@MorningStar.Com>


Index:patchlevel.h
*** ../patch4/patchlevel.h	Wed Jan 16 15:21:28 1991
--- ./patchlevel.h	Wed Aug 14 21:36:34 1991
***************
*** 1 ****
! # define	PATCHLEVEL	4
--- 1 ----
! # define	PATCHLEVEL	5
Index:README
*** ../patch4/README	Sat Dec 16 20:06:13 1989
--- ./README	Tue Feb 12 09:57:21 1991
***************
*** 1,3 ****
--- 1,8 ----
+ Below is the old README for pure BSD 4.3 systems.  See Readme.streams for
+ SunOS 4.* systems.
+ 					<karl@MorningStar.Com>
+ -------------------------------------------------------------------------
+ 
  The following files are included in the distribution:
  
  	README				- this file
Index:ipcp.c
*** ../patch4/ipcp.c	Tue Jan 15 11:10:39 1991
--- ./ipcp.c	Wed Aug 14 21:27:55 1991
***************
*** 42,47 ****
--- 42,50 ----
  #include "fsm.h"
  #include "ipcp.h"
  
+ short ip_vj_comp = IP_VJ_COMP;	/* VJ compression protocol for negotiation. */
+ 				/* Change back to 0x0037 for rfc1171 */
+ 				/* compatibility */
  
  void ipcp_resetci();		/* Reset our Configuration Information */
  int ipcp_cilen();		/* Return length of our CI */
***************
*** 235,241 ****
      }
  
      ADDCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     ADDCISHORT(CI_COMPRESSTYPE, go->neg_vj, IPCP_VJHDR)
  }
  
  
--- 238,244 ----
      }
  
      ADDCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     ADDCISHORT(CI_COMPRESSTYPE, go->neg_vj, ip_vj_comp)
  }
  
  
***************
*** 302,308 ****
      }
  
      ACKCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     ACKCISHORT(CI_COMPRESSTYPE, go->neg_vj, IPCP_VJHDR)
  
      /*
       * If there are any remaining CIs, then this packet is bad.
--- 305,311 ----
      }
  
      ACKCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     ACKCISHORT(CI_COMPRESSTYPE, go->neg_vj, ip_vj_comp)
  
      /*
       * If there are any remaining CIs, then this packet is bad.
***************
*** 434,440 ****
      }
  
      REJCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     REJCISHORT(CI_COMPRESSTYPE, go->neg_vj, IPCP_VJHDR)
  
      /*
       * If there are any remaining CIs, then this packet is bad.
--- 437,443 ----
      }
  
      REJCIADDRS(CI_ADDRS, go->neg_addrs, go->ouraddr, go->hisaddr)
!     REJCISHORT(CI_COMPRESSTYPE, go->neg_vj, ip_vj_comp)
  
      /*
       * If there are any remaining CIs, then this packet is bad.
***************
*** 557,568 ****
  	    LCPDEBUG((stderr, "(%d)", cishort));
  
  	    /*
! 	     * Compresstype must be IPCP_VJHDR.
  	     */
! 	    if (cishort != IPCP_VJHDR) {
  		DECPTR(sizeof (short), p);
  		orc = CONFNAK;
! 		PUTSHORT(IPCP_VJHDR, p);
  		break;
  	    }
  	    ho->neg_vj = 1;
--- 560,571 ----
  	    LCPDEBUG((stderr, "(%d)", cishort));
  
  	    /*
! 	     * Compresstype must be ip_vj_comp.
  	     */
! 	    if (cishort != ip_vj_comp) {
  		DECPTR(sizeof (short), p);
  		orc = CONFNAK;
! 		PUTSHORT(ip_vj_comp, p);
  		break;
  	    }
  	    ho->neg_vj = 1;
Index:ipcp.h
*** ../patch4/ipcp.h	Fri May 18 21:48:19 1990
--- ./ipcp.h	Wed Aug 14 21:28:49 1991
***************
*** 23,30 ****
  #define CI_ADDRS	1	/* IP Addresses */
  #define CI_COMPRESSTYPE	2	/* Compression Type */
  
- #define IPCP_VJHDR	0x37	/* Van Jacobson header compression */
- 
  typedef struct ipcp_options {
      int neg_addrs : 1;		/* Negotiate IP Addresses? */
      u_long ouraddr, hisaddr;	/* Addresses in NETWORK BYTE ORDER */
--- 23,28 ----
Index:ppp.c
*** ../patch4/ppp.c	Wed Jan 16 15:21:30 1991
--- ./ppp.c	Fri Aug 16 13:28:02 1991
***************
*** 76,81 ****
--- 76,83 ----
  #include <sys/conf.h>
  #endif
  
+ # define	DEVNAME_SIZE	128	/* Buffer size for /dev/* filenames */
+ 
  #ifdef sun
  /*
   *	Get definition of SUNOS
***************
*** 101,107 ****
  int upap_debug = 0;		/* UPAP debug flag */
  
  char *progname;			/* Name of this program */
! char devname[32] = "/dev/tty";	/* Device name */
  char ifname[IFNAMSIZ];		/* Interface name */
  int ifunit;			/* Interface unit number */
  char inspeed = 0, outspeed = 0;	/* Input/Output speed */
--- 103,109 ----
  int upap_debug = 0;		/* UPAP debug flag */
  
  char *progname;			/* Name of this program */
! char devname[DEVNAME_SIZE] = "/dev/tty";	/* Device name */
  char ifname[IFNAMSIZ];		/* Interface name */
  int ifunit;			/* Interface unit number */
  char inspeed = 0, outspeed = 0;	/* Input/Output speed */
***************
*** 112,120 ****
  struct sgttyb initsgttyb;	/* Initial TTY sgttyb */
  #endif
  int initfdflags;		/* Initial file descriptor flags */
! int pid;			/* Our pid */
  #ifdef sun
! int	pgrpid;			/* Process Group ID */
  #endif
  char user[80];			/* User name */
  
--- 114,122 ----
  struct sgttyb initsgttyb;	/* Initial TTY sgttyb */
  #endif
  int initfdflags;		/* Initial file descriptor flags */
! pid_t	pid;			/* Our pid */
  #ifdef sun
! pid_t	pgrpid;			/* Process Group ID */
  #endif
  char user[80];			/* User name */
  
***************
*** 122,128 ****
  void hup(), intr(), term(), alrm(), io(), incdebug(), nodebug();
  int setdebug(), setpassive(), noopt(), novj(), noupap(), requpap();
  int setspeed(), noaccomp(), noasyncmap(), noipaddr(), nomagicnumber();
! int setasyncmap();
  int setmru(), nomru(), nopcomp();
  void getuserpasswd();
  
--- 124,130 ----
  void hup(), intr(), term(), alrm(), io(), incdebug(), nodebug();
  int setdebug(), setpassive(), noopt(), novj(), noupap(), requpap();
  int setspeed(), noaccomp(), noasyncmap(), noipaddr(), nomagicnumber();
! int setasyncmap(), setold();
  int setmru(), nomru(), nopcomp();
  void getuserpasswd();
  
***************
*** 157,162 ****
--- 159,165 ----
      "+ua", requpap,			/* Require UPAP authentication */
      "-ua", noupap,			/* Don't allow UPAP authentication */
      "-vj", novj,			/* Disable VJ compression */
+     "old", setold,			/* Backward compatibility mode */
  #if 0
      "local", setlocalipaddr,
      "remote", setremoteipaddr,
***************
*** 200,205 ****
--- 203,209 ----
  	+ua		Require UPAP authentication\n\
  	-ua		Don't allow UPAP authentication\n\
  	-vj		Disable VJ compression\n\
+ 	old		Backward compatibility mode for use with old PPP versions\n\
  	<device>	Communicate over the named device\n\
  	<speed>		Set the baud rate to <speed>\n\
  	<loc>:<rem>	Set the local and/or remote interface IP\n\
***************
*** 219,230 ****
  	for(; str_module_count > 0; str_module_count--) {
  		if(ioctl(fd, I_PUSH, str_modules[str_module_count-1].modname)) {
  			if(debug)
! 				printf("str_restore: couldn't push module %s\n",
  					str_modules[str_module_count-1].modname);
  		}
  		else {
  			if(debug)
! 				printf("str_restore: pushed module %s\n",
  					str_modules[str_module_count-1].modname);
  		}
  	}
--- 223,236 ----
  	for(; str_module_count > 0; str_module_count--) {
  		if(ioctl(fd, I_PUSH, str_modules[str_module_count-1].modname)) {
  			if(debug)
! 				fprintf(stderr,
! 					"str_restore: couldn't push module %s\n",
  					str_modules[str_module_count-1].modname);
  		}
  		else {
  			if(debug)
! 				fprintf(stderr,
! 					"str_restore: pushed module %s\n",
  					str_modules[str_module_count-1].modname);
  		}
  	}
***************
*** 296,305 ****
--- 302,321 ----
      /*
       * Initialize state.
       */
+ #if defined(sun) && defined(SUNOS) && SUNOS >= 41
+     if ((pgrpid = setsid()) < 0)
+ 	pgrpid = getpgrp(0);
+ #endif
      if ((fd = open(devname, O_RDWR /*| O_NDELAY*/)) < 0) {
  	perror(devname);
  	exit(1);
      }
+ #if defined(sun) && defined(SUNOS) && SUNOS >= 41
+     if (getpid() != pgrpid && tcsetpgrp(fd, pgrpid) < 0) {
+   	perror("ppp: tcsetpgrp()");
+   	exit(1);
+     }
+ #endif
      if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
  	perror("ppp: socket");
  	exit(1);
***************
*** 308,314 ****
  	while(1)	{ /* go through and save the name of all the modules, then pop em */
  		if(!ioctl(fd, I_LOOK, str_modules[str_module_count].modname))
  			if(debug)
! 				printf("popped stream module : %s\n",str_modules[str_module_count].modname);
  		if(!ioctl(fd, I_POP, 0))
  			str_module_count++;
  		else
--- 324,332 ----
  	while(1)	{ /* go through and save the name of all the modules, then pop em */
  		if(!ioctl(fd, I_LOOK, str_modules[str_module_count].modname))
  			if(debug)
! 				fprintf(stderr,
! 					"popped stream module : %s\n",
! 					str_modules[str_module_count].modname);
  		if(!ioctl(fd, I_POP, 0))
  			str_module_count++;
  		else
***************
*** 396,415 ****
  #endif
      sprintf(ifname, "ppp%d", ifunit);
      if (debug)
! 	printf("Interface %s.\n", ifname);
  
      pid = getpid();
      if (debug)
! 	printf("Pid %d.\n", pid);
  
! # if defined(sun) && defined(SUNOS) && SUNOS >= 41
!     if ((pgrpid = setsid()) < 0)
! 	pgrpid = getpgrp(0);
!     if (tcsetpgrp(fd, pgrpid) < 0) {
!   	perror("ppp: tcsetpgrp()");
!   	exit(1);
! 	}
! # else
      if (ioctl(fd, TIOCSPGRP, &pid) < 0) {
  	perror("ppp: ioctl(TIOCSPGRP)");
  	exit(1);
--- 414,426 ----
  #endif
      sprintf(ifname, "ppp%d", ifunit);
      if (debug)
! 	fprintf(stderr, "Interface %s.\n", ifname);
  
      pid = getpid();
      if (debug)
! 	fprintf(stderr, "Pid %d.\n", pid);
  
! # if !defined(sun) || !defined(SUNOS) || SUNOS < 41
      if (ioctl(fd, TIOCSPGRP, &pid) < 0) {
  	perror("ppp: ioctl(TIOCSPGRP)");
  	exit(1);
***************
*** 561,567 ****
      struct callout *newp, **oldpp;
      
      if (debug > 2)
! 	printf("Timeout %x:%x in %d seconds.\n", (int) func, (int) arg, time);
  
      /*
       * Allocate timeout.
--- 572,579 ----
      struct callout *newp, **oldpp;
      
      if (debug > 2)
! 	fprintf(stderr, "Timeout %x:%x in %d seconds.\n",
! 		(int) func, (int) arg, time);
  
      /*
       * Allocate timeout.
***************
*** 596,602 ****
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout->c_time;
  	if (debug > 2)
! 	    printf("Setting itimer for %d seconds.\n", itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
--- 608,615 ----
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout->c_time;
  	if (debug > 2)
! 	    fprintf(stderr, "Setting itimer for %d seconds.\n",
! 		    itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
***************
*** 622,628 ****
      int reschedule = 0;
  
      if (debug > 2)
! 	printf("Untimeout %x:%x.\n", (int) func, (int) arg);
  
      /*
       * If the first callout is unscheduled then we have to set a new
--- 635,641 ----
      int reschedule = 0;
  
      if (debug > 2)
! 	fprintf(stderr, "Untimeout %x:%x.\n", (int) func, (int) arg);
  
      /*
       * If the first callout is unscheduled then we have to set a new
***************
*** 653,659 ****
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout ? callout->c_time : 0;
  	if (debug > 2)
! 	    printf("Setting itimer for %d seconds.\n", itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
--- 666,673 ----
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout ? callout->c_time : 0;
  	if (debug > 2)
! 	    fprintf(stderr, "Setting itimer for %d seconds.\n",
! 		    itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
***************
*** 735,741 ****
  void hup()
  {
      if (debug > 1)
! 	printf("Hangup\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_lowerdown(0);		/* Reset connection */
  }
--- 749,755 ----
  void hup()
  {
      if (debug > 1)
! 	fprintf(stderr, "Hangup\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_lowerdown(0);		/* Reset connection */
  }
***************
*** 749,755 ****
  void term()
  {
      if (debug > 1)
! 	printf("Terminate\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_close(0);		/* Close connection */
  }
--- 763,769 ----
  void term()
  {
      if (debug > 1)
! 	fprintf(stderr, "Terminate\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_close(0);		/* Close connection */
  }
***************
*** 763,769 ****
  void intr()
  {
      if (debug > 1)
! 	printf("Interrupt\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_close(0);		/* Close connection */
  }
--- 777,783 ----
  void intr()
  {
      if (debug > 1)
! 	fprintf(stderr, "Interrupt\n");
      adjtimeout();		/* Adjust timeouts */
      lcp_close(0);		/* Close connection */
  }
***************
*** 780,786 ****
      struct callout *freep;
  
      if (debug > 1)
! 	printf("Alarm\n");
  
      /*
       * Call and free first scheduled timeout and any that were scheduled
--- 794,800 ----
      struct callout *freep;
  
      if (debug > 1)
! 	fprintf(stderr, "Alarm\n");
  
      /*
       * Call and free first scheduled timeout and any that were scheduled
***************
*** 803,809 ****
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout->c_time;
  	if (debug > 2)
! 	    printf("Setting itimer for %d seconds.\n", itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
--- 817,824 ----
  	    itv.it_value.tv_usec = 0;
  	itv.it_value.tv_sec = callout->c_time;
  	if (debug > 2)
! 	    fprintf(stderr, "Setting itimer for %d seconds.\n",
! 		    itv.it_value.tv_sec);
  	if (setitimer(ITIMER_REAL, &itv, NULL)) {
  	    perror("ppp: setitimer(ITIMER_REAL)");
  	    exit(1);
***************
*** 830,836 ****
      struct strbuf str;
  #endif
      if (debug > 1)
! 	printf("IO\n");
      adjtimeout();		/* Adjust timeouts */
  
      for (;;) {			/* Read all available packets */
--- 845,851 ----
      struct strbuf str;
  #endif
      if (debug > 1)
! 	fprintf(stderr, "IO\n");
      adjtimeout();		/* Adjust timeouts */
  
      for (;;) {			/* Read all available packets */
***************
*** 850,860 ****
  		exit(1);
  	}
  	else if(len && debug > 2) 
! 			fprintf(stderr,"ppp: getmsg returns 0x%x\n",len);
  
  	if(str.len < 0) {
  		if(debug > 2)
! 			fprintf(stderr,"ppp: getmsg short return length %d\n",str.len);
  		return;
  	}
  		
--- 865,876 ----
  		exit(1);
  	}
  	else if(len && debug > 2) 
! 			fprintf(stderr, "ppp: getmsg returns 0x%x\n",len);
  
  	if(str.len < 0) {
  		if(debug > 2)
! 			fprintf(stderr, "ppp: getmsg short return length %d\n",
! 				str.len);
  		return;
  	}
  		
***************
*** 1150,1155 ****
--- 1166,1185 ----
  
  
  /*
+  *	setold - Set backward compatibility mode
+  */
+ int setold(argcp, argvp)
+ int *argcp;
+ char ***argvp;
+     {
+     extern short ip_vj_comp;
+ 
+     ip_vj_comp = 0x0037;
+     --*argcp, ++*argvp;
+     return (1);
+     }
+ 
+ /*
   * Valid speeds.
   */
  struct speed {
***************
*** 1253,1259 ****
      int *argcp;
      char ***argvp;
  {
!     char dev[32];
      char *cp = **argvp;
      struct stat statbuf;
      char *tty, *ttyname();
--- 1283,1289 ----
      int *argcp;
      char ***argvp;
  {
!     char dev[DEVNAME_SIZE];
      char *cp = **argvp;
      struct stat statbuf;
      char *tty, *ttyname();
***************
*** 1281,1287 ****
       * or we are running ppp on the control terminal, then we can
       * allow authentication to be requested.
       */
!     tty = ttyname(fileno(stdin));
      if (lcp_wantoptions[0].neg_upap == 0 &&
  	strcmp(devname, "/dev/tty") &&
  	strcmp(devname, tty)) {
--- 1311,1318 ----
       * or we are running ppp on the control terminal, then we can
       * allow authentication to be requested.
       */
!     if ((tty = ttyname(fileno(stdin))) == NULL)
!       tty = ""; /* running from init means no stdin.  Null kills strcmp -KWK */
      if (lcp_wantoptions[0].neg_upap == 0 &&
  	strcmp(devname, "/dev/tty") &&
  	strcmp(devname, tty)) {
***************
*** 1427,1433 ****
  	*msg = "Login incorrect";
  	*msglen = strlen(*msg);
  	if(debug > 2)
! 		fprintf(stderr,"ppp: upap login password '%s' incorrect\n",passwd);
  	/*
  	 * Frustrate passwd stealer programs.
  	 * Allow 10 tries, but start backing off after 3 (stolen from login).
--- 1458,1465 ----
  	*msg = "Login incorrect";
  	*msglen = strlen(*msg);
  	if(debug > 2)
! 		fprintf(stderr, "ppp: upap login password '%s' incorrect\n",
! 			passwd);
  	/*
  	 * Frustrate passwd stealer programs.
  	 * Allow 10 tries, but start backing off after 3 (stolen from login).
Index:ppp.h
*** ../patch4/ppp.h	Fri May 18 22:05:25 1990
--- ./ppp.h	Thu Aug 15 12:31:21 1991
***************
*** 93,98 ****
--- 93,99 ----
  #define LCP		0xc021	/* Link Control Protocol */
  #define IPCP		0x8021	/* IP Control Protocol */
  #define UPAP		0xc023	/* User/Password Authentication Protocol */
+ #define IP_VJ_COMP	0x002d	/* VJ TCP compressed IP packet */
  #define DLLHEADERLEN	(sizeof (u_char) + sizeof (u_char) + sizeof (u_short))
  #define MTU		1500	/* Default MTU */
  
Index:INSTALL/README
*** ../patch4/INSTALL/README	Tue Jan 15 11:12:17 1991
--- ./INSTALL/README	Thu Aug 15 12:28:58 1991
***************
*** 15,25 ****
   stty -tostop
   exec /usr/local/etc/ppp 137.175.2.7:
  
! I have this line in my ~/.xinitrc file:
! 
!  ppp-on &
! 
! This shell script, plus the ppp-off, unlock and fix-cua scripts and
  the source to the chat program are included.  You will need to heavily
  modify these to suit your own situation, including Internet addresses,
  machine names, telephone numbers, modem dialing commands, baud rates,
--- 15,22 ----
   stty -tostop
   exec /usr/local/etc/ppp 137.175.2.7:
  
! I use the ppp-on command to bring up a connection, and ppp-off to shut
! it down.  These shell scripts, plus the unlock and fix-cua scripts and
  the source to the chat program are included.  You will need to heavily
  modify these to suit your own situation, including Internet addresses,
  machine names, telephone numbers, modem dialing commands, baud rates,
***************
*** 49,57 ****
   crw-rw-rw-  1 root     staff     12, 128 Nov 20 09:14 /dev/cua
   crw--w--w-  1 root     wheel     12,   0 Nov 20 08:25 /dev/ttya
   crappie 14% grep ttya /etc/ttytab
!  ttya    "/usr/etc/getty std.19200"      unknown         on secure
   crappie 15%
  
  Make sure your modem passes data transparently; watch out especially
  for ^S, ^Q, ^P (UUCP spoofing) and parity problems.  I have a Telebit
  Trailblazer+ attached to /dev/ttya with the following register
--- 46,59 ----
   crw-rw-rw-  1 root     staff     12, 128 Nov 20 09:14 /dev/cua
   crw--w--w-  1 root     wheel     12,   0 Nov 20 08:25 /dev/ttya
   crappie 14% grep ttya /etc/ttytab
!  ttya    "/usr/etc/getty std.19200"      unknown         on
   crappie 15%
  
+ On SunOS 4.1 and later, make sure that the /etc/ttytab line for ttya
+ doesn't say "local":
+ 
+   ttya	"/usr/etc/getty std.38400"	unknown		on
+ 
  Make sure your modem passes data transparently; watch out especially
  for ^S, ^Q, ^P (UUCP spoofing) and parity problems.  I have a Telebit
  Trailblazer+ attached to /dev/ttya with the following register
***************
*** 161,166 ****
  the gateway machine, and all PPP-connected external machines are on the
  137.175.6 subnet.
  
! Send me mail if you have any questions.
  
  Karl Fox <karl@MorningStar.Com>
--- 163,169 ----
  the gateway machine, and all PPP-connected external machines are on the
  137.175.6 subnet.
  
! Send me mail or post to the newsgroup comp.protocols.ppp if you have
! any questions.
  
  Karl Fox <karl@MorningStar.Com>
Index:INSTALL/chat.c
*** ../patch4/INSTALL/chat.c	Wed Jan 16 15:21:30 1991
--- ./INSTALL/chat.c	Wed Aug 14 21:12:50 1991
***************
*** 13,19 ****
   *		(614)451-1883
   */
  
! static char sccs_id[] = "@(#)chat.c	1.3";
  
  # include	<stdio.h>
  # include	<termio.h>
--- 13,19 ----
   *		(614)451-1883
   */
  
! static char sccs_id[] = "@(#)chat.c	1.7";
  
  # include	<stdio.h>
  # include	<termio.h>
***************
*** 22,29 ****
  # include	<errno.h>
  # include	<sys/types.h>
  # include	<sys/stat.h>
- # include	<ctype.h>
  
  # define	STR_LEN		1024
  
  /*************** Micro getopt() *********************************************/
--- 22,37 ----
  # include	<errno.h>
  # include	<sys/types.h>
  # include	<sys/stat.h>
  
+ # ifdef sun
+ # include	<pixrect/pr_impl_util.h>
+ # if defined(SUNOS) && SUNOS >= 41
+ # ifndef HDB
+ # define	HDB
+ # endif
+ # endif
+ # endif
+ 
  # define	STR_LEN		1024
  
  /*************** Micro getopt() *********************************************/
***************
*** 52,62 ****
  #  endif /* HDB */
  # endif /* LOCK_DIR */
  
  int verbose = 0;
  int quiet = 0;
  char *lock_file = (char *)0;
! int timeout = 30;
  
  /*
   *	chat [ -v ] [ -t timeout ] [ -l lock-file ] \
   *		[...[[expect[-say[-expect...]] say expect[-say[-expect]] ...]]]
--- 60,77 ----
  #  endif /* HDB */
  # endif /* LOCK_DIR */
  
+ # define	MAX_ABORTS	50
+ # define	DEFAULT_CHAT_TIMEOUT	30
+ 
  int verbose = 0;
  int quiet = 0;
  char *lock_file = (char *)0;
! int timeout = DEFAULT_CHAT_TIMEOUT;
  
+ char *abort_string[MAX_ABORTS], *fail_reason = (char *)0,
+ 	fail_buffer[50];
+ int n_aborts = 0, abort_next = 0, timeout_next = 0;
+ 
  /*
   *	chat [ -v ] [ -t timeout ] [ -l lock-file ] \
   *		[...[[expect[-say[-expect...]] say expect[-say[-expect]] ...]]]
***************
*** 109,115 ****
  	    send(arg);
  	}
  
!     exit(0);
      }
  
  /*
--- 124,130 ----
  	    send(arg);
  	}
  
!     terminate(0);
      }
  
  /*
***************
*** 148,154 ****
      fprintf(stderr, format, arg1, arg2, arg3, arg4);
      fprintf(stderr, "\n");
      unlock();
!     exit(1);
      }
  
  /*
--- 163,169 ----
      fprintf(stderr, format, arg1, arg2, arg3, arg4);
      fprintf(stderr, "\n");
      unlock();
!     terminate(1);
      }
  
  /*
***************
*** 166,172 ****
      sprintf(message + strlen(message), format, arg1, arg2, arg3, arg4);
      perror(message);
      unlock();
!     exit(1);
      }
  
  int alarmed = 0;
--- 181,187 ----
      sprintf(message + strlen(message), format, arg1, arg2, arg3, arg4);
      perror(message);
      unlock();
!     terminate(1);
      }
  
  int alarmed = 0;
***************
*** 202,209 ****
--- 217,237 ----
  	    sysfatal("Can't set file mode flags on stdin");
      }
  
+ sigint()
+     {
+     fatal("SIGINT");
+     }
+ 
+ sigterm()
+     {
+     fatal("SIGTERM");
+     }
+ 
  init()
      {
+     signal(SIGINT, sigint);
+     signal(SIGTERM, sigterm);
+ 
      if (lock_file)
  	lock();
  
***************
*** 219,229 ****
      if (ioctl(0, TCGETA, &t) < 0)
  	sysfatal("Can't get terminal parameters");
  
!     t.c_iflag = IXOFF | IXON | ISTRIP | IGNPAR | IGNBRK;
!     t.c_cflag = CLOCAL | CREAD | CS8 | (t.c_cflag & CBAUD) | HUPCL;
      t.c_lflag = 0;
!     t.c_cc[VERASE] = 0;
!     t.c_cc[VKILL] = 0;
      t.c_cc[VMIN] = 1;
      t.c_cc[VTIME] = 0;
  
--- 247,256 ----
      if (ioctl(0, TCGETA, &t) < 0)
  	sysfatal("Can't get terminal parameters");
  
!     t.c_cflag = (t.c_cflag & CBAUD) | CREAD | CS8 | HUPCL | CLOCAL;
!     t.c_iflag = IGNBRK | IXOFF | IXON | ISTRIP | IGNPAR;
      t.c_lflag = 0;
!     t.c_cc[VERASE] = t.c_cc[VKILL] = 0;
      t.c_cc[VMIN] = 1;
      t.c_cc[VTIME] = 0;
  
***************
*** 231,236 ****
--- 258,268 ----
  	sysfatal("Can't set terminal parameters");
      }
  
+ terminate(status)
+     {
+     exit(status);
+     }
+ 
  /*
   *	Create a lock file for the named lock device
   */
***************
*** 245,252 ****
  
      if ((fd = open(lock_file, O_EXCL | O_CREAT | O_RDWR, 0644)) < 0)
  	{
  	lock_file = (char *)0;	/* Don't remove someone else's lock file! */
! 	sysfatal("Can't get lock file '%s'", lock_file);
  	}
  
  # ifdef HDB
--- 277,286 ----
  
      if ((fd = open(lock_file, O_EXCL | O_CREAT | O_RDWR, 0644)) < 0)
  	{
+ 	char *s = lock_file;
+ 
  	lock_file = (char *)0;	/* Don't remove someone else's lock file! */
! 	sysfatal("Can't get lock file '%s'", s);
  	}
  
  # ifdef HDB
***************
*** 281,287 ****
      {
      char temp[STR_LEN];
      register char *s1;
!     int add_newline = sending;
  
      for (s1 = temp; *s; ++s)
  	 switch (*s)
--- 315,321 ----
      {
      char temp[STR_LEN];
      register char *s1;
!     int add_return = sending;
  
      for (s1 = temp; *s; ++s)
  	 switch (*s)
***************
*** 289,303 ****
  	     case '\\':
  		 switch (*++s)
  		     {
  		     case 'q':	quiet = ! quiet; break;
  		     case 'r':	*s1++ = '\r'; break;
  		     case 'n':	*s1++ = '\n'; break;
  		     case 's':	*s1++ = ' '; break;
  		     case 'c':	if (sending && s[1] == '\0')
! 				    add_newline = 0;
  				else
  				    *s1++ = *s;
  				break;
  		     default:	*s1++ = *s;
  		     }
  
--- 323,347 ----
  	     case '\\':
  		 switch (*++s)
  		     {
+ 		     case '\\':
+ 		     case 'd':	if (sending)
+ 				    *s1++ = '\\';
+ 
+ 				*s1++ = *s;
+ 				break;
+ 
  		     case 'q':	quiet = ! quiet; break;
  		     case 'r':	*s1++ = '\r'; break;
  		     case 'n':	*s1++ = '\n'; break;
  		     case 's':	*s1++ = ' '; break;
+ 
  		     case 'c':	if (sending && s[1] == '\0')
! 				    add_return = 0;
  				else
  				    *s1++ = *s;
+ 
  				break;
+ 
  		     default:	*s1++ = *s;
  		     }
  
***************
*** 311,318 ****
  		 *s1++ = *s;
  	     }
      
!     if (add_newline)
! 	*s1++ = '\n';
  
      *s1 = '\0';
      return (copyof(temp));
--- 355,362 ----
  		 *s1++ = *s;
  	     }
      
!     if (add_return)
! 	*s1++ = '\r';
  
      *s1 = '\0';
      return (copyof(temp));
***************
*** 324,329 ****
--- 368,385 ----
  expect(s)
  register char *s;
      {
+     if (strcmp(s, "ABORT") == 0)
+ 	{
+ 	++abort_next;
+ 	return;
+ 	}
+ 
+     if (strcmp(s, "TIMEOUT") == 0)
+ 	{
+ 	++timeout_next;
+ 	return;
+ 	}
+ 
      while (*s)
  	{
  	register char *hyphen;
***************
*** 367,380 ****
  		return;
  	    else
  		{
! 		fprintf(stderr, "Failed\n");
  		fflush(stderr);
  		unlock();
! 		exit(1);
  		}
  	}
      }
  
  /*
   *
   */
--- 423,460 ----
  		return;
  	    else
  		{
! 		if (fail_reason)
! 		    fprintf(stderr, "Failed(%s)\n", fail_reason);
! 		else
! 		    fprintf(stderr, "Failed\n");
! 
  		fflush(stderr);
  		unlock();
! 		terminate(1);
  		}
  	}
      }
  
+ char *character(c)
+ char c;
+     {
+     static char string[10];
+     char *meta;
+ 
+     meta = (c & 0x80) ? "M-" : "";
+     c &= 0x7F;
+ 
+     if (c < 32)
+ 	sprintf(string, "%s^%c", meta, (int)c + '@');
+     else
+ 	if (c == 127)
+ 	    sprintf(string, "%s^?", meta);
+ 	else
+ 	    sprintf(string, "%s%c", meta, c);
+ 
+     return (string);
+     }
+ 
  /*
   *
   */
***************
*** 381,409 ****
  send(s)
  register char *s;
      {
!     if ( ! put_string(s))
  	{
! 	fprintf(stderr, "Failed\n");
! 	fflush(stderr);
! 	unlock();
! 	exit(1);
! 	}
!     }
  
! char *character(c)
! char c;
!     {
!     static char string[10];
  
!     if (isgraph(c) || c == ' ')
! 	sprintf(string, "%c", c);
      else
! 	if (c < 32)
! 	    sprintf(string, "^%c", (int)c + 'A' - 1);
! 	else
! 	    sprintf(string, "\\%03o", (int)c & 0xFF);
  
!     return (string);
      }
  
  int get_char()
--- 461,522 ----
  send(s)
  register char *s;
      {
!     if (abort_next)
  	{
! 	char *s1;
  
! 	abort_next = 0;
  
! 	if (n_aborts >= MAX_ABORTS)
! 	    fatal("Too many ABORT strings");
! 
! 	s1 = clean(s, 0);
! 
! 	if (strlen(s1) > strlen(s))
! 	    fatal("Illegal ABORT string ('%s')\n", s);
! 
! 	if (strlen(s1) > sizeof fail_buffer - 1)
! 	    fatal("Too long ABORT string ('%s')\n", s);
! 
! 	strcpy(s, s1);
! 	abort_string[n_aborts++] = s;
! 
! 	if (verbose)
! 	    {
! 	    register char *s1 = s;
! 
! 	    fprintf(stderr, "abort on (");
! 
! 	    for (s1 = s; *s1; ++s1)
! 		fprintf(stderr, "%s", character(*s1));
! 
! 	    fprintf(stderr, ")\n");
! 	    fflush(stderr);
! 	    }
! 	}
      else
! 	if (timeout_next)
! 	    {
! 	    timeout_next = 0;
! 	    timeout = atoi(s);
  
! 	    if (timeout <= 0)
! 		timeout = DEFAULT_CHAT_TIMEOUT;
! 
! 	    if (verbose)
! 		{
! 		fprintf(stderr, "timeout set to %d seconds\n", timeout);
! 		fflush(stderr);
! 		}
! 	    }
! 	else
! 	    if ( ! put_string(s))
! 		{
! 		fprintf(stderr, "Failed\n");
! 		fflush(stderr);
! 		unlock();
! 		terminate(1);
! 		}
      }
  
  int get_char()
***************
*** 463,472 ****
  int put_string(s)
  register char *s;
      {
!     register char *orig_s;
  
-     orig_s = s = clean(s, 1);
- 
      if (verbose)
  	{
  	fprintf(stderr, "send (");
--- 576,583 ----
  int put_string(s)
  register char *s;
      {
!     s = clean(s, 1);
  
      if (verbose)
  	{
  	fprintf(stderr, "send (");
***************
*** 474,482 ****
  	if (quiet)
  	    fprintf(stderr, "??????");
  	else
! 	    for (orig_s = s; *orig_s; ++orig_s)
! 		fprintf(stderr, "%s", character(*orig_s));
  
  	fprintf(stderr, ")\n");
  	fflush(stderr);
  	}
--- 585,597 ----
  	if (quiet)
  	    fprintf(stderr, "??????");
  	else
! 	    {
! 	    register char *s1 = s;
  
+ 	    for (s1 = s; *s1; ++s1)
+ 		fprintf(stderr, "%s", character(*s1));
+ 	    }
+ 
  	fprintf(stderr, ")\n");
  	fflush(stderr);
  	}
***************
*** 484,489 ****
--- 599,617 ----
      alarm(timeout); alarmed = 0;
  
      for ( ; *s; ++s)
+ 	{
+ 	register char c = *s;
+ 
+ 	if (c == '\\')
+ 	    if ((c = *++s) == '\0')
+ 		break;
+ 	    else
+ 		if (c == 'd')		/* \d -- Delay */
+ 		    {
+ 		    sleep(2);
+ 		    continue;
+ 		    }
+ 
  	if (alarmed || put_char(*s) < 0)
  	    {
  	    extern int errno;
***************
*** 502,507 ****
--- 630,636 ----
  
  	    return (0);
  	    }
+ 	}
  
      alarm(0); alarmed = 0;
      return (1);
***************
*** 513,535 ****
  int get_string(string)
  register char *string;
      {
!     int c, printed = 0;
!     register char *orig_s, *s;
  
!     s = string = clean(string, 0);
  
      if (verbose)
  	{
  	fprintf(stderr, "expect (");
  
! 	for (orig_s = s; *orig_s; ++orig_s)
! 	    fprintf(stderr, "%s", character(*orig_s));
  
  	fprintf(stderr, ")\n");
  	fflush(stderr);
  	}
  
!     if (*s == '\0')
  	{
  	if (verbose)
  	    {
--- 642,669 ----
  int get_string(string)
  register char *string;
      {
!     char temp[STR_LEN];
!     int c, printed = 0, len;
!     register char *s = temp, *end = s + STR_LEN;
  
!     fail_reason = (char *)0;
!     string = clean(string, 0);
!     len = strlen(string);
  
      if (verbose)
  	{
+ 	register char *s1;
+ 
  	fprintf(stderr, "expect (");
  
! 	for (s1 = string; *s1; ++s1)
! 	    fprintf(stderr, "%s", character(*s1));
  
  	fprintf(stderr, ")\n");
  	fflush(stderr);
  	}
  
!     if (len == 0)
  	{
  	if (verbose)
  	    {
***************
*** 544,549 ****
--- 678,685 ----
  
      while ( ! alarmed && (c = get_char()) >= 0)
  	{
+ 	int n, abort_len;
+ 
  	if (verbose)
  	    {
  	    if (c == '\n')
***************
*** 554,568 ****
  	    fflush(stderr);
  	    }
  
! 	if (c == *s)
! 	    ++s;
! 	else
! 	    s = string;
  
! 	if (*s == '\0')
  	    {
  	    if (verbose)
  		{
  		fprintf(stderr, "got it\n");
  		fflush(stderr);
  		}
--- 690,715 ----
  	    fflush(stderr);
  	    }
  
! 	*s++ = c;
  
! 	if (s >= end)
  	    {
  	    if (verbose)
  		{
+ 		fprintf(stderr, " -- too much data\n");
+ 		fflush(stderr);
+ 		}
+ 
+ 	    alarm(0); alarmed = 0;
+ 	    return (0);
+ 	    }
+ 
+ 	if (s - temp >= len &&
+ 	    c == string[len - 1] &&
+ 	    strncmp(s - len, string, len) == 0)
+ 	    {
+ 	    if (verbose)
+ 		{
  		fprintf(stderr, "got it\n");
  		fflush(stderr);
  		}
***************
*** 571,578 ****
  	    return (1);
  	    }
  
  	if (alarmed && verbose)
! 	    warn("get_string() has 'alarmed' on before read");
  	}
  
      alarm(0);
--- 718,740 ----
  	    return (1);
  	    }
  
+ 	for (n = 0; n < n_aborts; ++n)
+ 	    if (s - temp >= (abort_len = strlen(abort_string[n])) &&
+ 		strncmp(s - abort_len, abort_string[n], abort_len) == 0)
+ 		{
+ 		if (verbose)
+ 		    {
+ 		    fprintf(stderr, " -- failed\n");
+ 		    fflush(stderr);
+ 		    }
+ 
+ 		alarm(0); alarmed = 0;
+ 		strcpy(fail_reason = fail_buffer, abort_string[n]);
+ 		return (0);
+ 		}
+ 
  	if (alarmed && verbose)
! 	    warn("Alarm synchronization problem");
  	}
  
      alarm(0);
Index:INSTALL/fix-cua
*** ../patch4/INSTALL/fix-cua	Tue Jan 15 11:12:18 1991
--- ./INSTALL/fix-cua	Wed Aug 14 21:50:43 1991
***************
*** 1,6 ****
  #!/bin/sh
  
! if [ -f /usr/spool/uucp/LCK..cua ]
  then
      echo "/dev/cua is locked" 2>&1
      exit 1
--- 1,6 ----
  #!/bin/sh
  
! if [ -f /usr/spool/locks/LCK..cua ]
  then
      echo "/dev/cua is locked" 2>&1
      exit 1
Index:INSTALL/ppp-on
*** ../patch4/INSTALL/ppp-on	Tue Jan 15 11:12:19 1991
--- ./INSTALL/ppp-on	Wed Aug 14 21:49:50 1991
***************
*** 3,67 ****
  #
  #	ppp-on
  #
! #	Put up a button to set up or shut down a PPP link
  #
  
! font="-fn lucidasans-italic-10"
  
! while :
! do
!     if [ -f /usr/spool/uucp/LCK..cua ]
!     then
! 	if xlogout $* $font -label "(PPP device is locked)"
! 	then
! 	    continue
! 	else
! 	    exit 1
! 	fi
!     fi
  
!     if xlogout $* $font -label "Bring PPP Up"
      then
! 	:
      else
  	exit 1
      fi
! 
!     if [ -f /usr/spool/uucp/LCK..cua ]
!     then
! 	continue
!     fi
! 
!     reason=
! 
!     fix-cua
! 
!     (
! 	stty 19200 -tostop
! 
! 	if chat -l LCK..cua "" AT OK ATDT4511234 CONNECT "" ogin: Pkarl ssword: \\q<password on remora for Pkarl>
! 	then
! 	    ppp 137.175.6.3: /dev/cua &
! 	    sleep 10
! 	    (
! 	    if xlogout $* $font -label "Shut PPP Down"
! 	    then
! 		:
! 	    else
! 		exit 1
! 	    fi
! 
! 	    ppp-off
! 	    wait
! 	    unlock LCK..cua
! 	    ) 0>&2 1>&2
! 	else
! 	    if xlogout $* $font -label "(PPP call failed)"
! 	    then
! 		:
! 	    else
! 		exit 1
! 	    fi
! 	fi
!     ) < /dev/cua > /dev/cua
! done
--- 3,29 ----
  #
  #	ppp-on
  #
! #	Set up a PPP link
  #
  
! if [ -f /usr/spool/locks/LCK..cua ]
! then
!     echo "PPP device is locked"
!     exit 1
! fi
  
! fix-cua
  
! (
!     stty 19200 -tostop
! 
!     if chat -l LCK..cua ABORT "NO CARRIER" ABORT BUSY "" ATZ OK ATs50=255s111=0DT4511234 CONNECT "" ogin: Pkarl ssword: \\q<password on remora for Pkarl>
      then
! 	ppp mru 1500 137.175.6.3: /dev/cua &
! 	sleep 10
! 	exit 0
      else
+ 	echo "PPP call failed" 1>&2
  	exit 1
      fi
! ) < /dev/cua > /dev/cua
Index:INSTALL/unlock
*** ../patch4/INSTALL/unlock	Tue Jan 15 11:12:22 1991
--- ./INSTALL/unlock	Wed Aug 14 21:50:57 1991
***************
*** 1,6 ****
  #!/bin/sh
  
! LOCKDIR=/usr/spool/uucp
  
  case "$1" in
      "")		echo "Usage: unlock lockfile"; exit 1 ;;
--- 1,6 ----
  #!/bin/sh
  
! LOCKDIR=/usr/spool/locks
  
  case "$1" in
      "")		echo "Usage: unlock lockfile"; exit 1 ;;
