From terminator!caen!sdd.hp.com!elroy.jpl.nasa.gov!nntp-server.caltech.edu!gmc Fri Jan 10 10:39:33 1992
Article: 396 of comp.protocols.ppp
Newsgroups: comp.protocols.ppp
Path: terminator!caen!sdd.hp.com!elroy.jpl.nasa.gov!nntp-server.caltech.edu!gmc
From: gmc@Quotron.COM (Greg Christy)
Subject: Re: PPP on Sparc eats up memory
Message-ID: <gmc.695006146@Quotron.COM>
Sender: news@cco.caltech.edu
Nntp-Posting-Host: premises1.quotron.com
Reply-To: gmc@Quotron.COM
Organization: Quotron Systems, Inc.
References: <1992Jan4.190646.12030@bnrmtl.bnr.ca>
Date: Thu, 9 Jan 92 20:15:46 EST

In <1992Jan4.190646.12030@bnrmtl.bnr.ca> piec@bnrmtl.bnr.ca (Pierre Corriveau) writes:

>I am using ppp-sunos4.1.pl6 on a Sparc 2 running SunOS 4.1.1.  If I turn on
>PPP and let it sit for while, it slowly eats up memory on the Sparc, until it 
>eventually runs out).

>The increments in size seems to be in 8K chunks and they occurs every now
>and then when the link is inactive (but up).  If you look at your modem 
>lights, during link inactivity PPP is exchanging packets every now and then:
>that's when the increase in memory usage occurs.

>The other end of my PPP link is MST-PPP Ultrix 1.2Beta.

>Any ideas why?

>-- 
>Pierre Corriveau
>Bell-Northern Research, Montreal, Canada
>piec@bnr.ca  


The following patch will plug a couple of the nastier memory leaks in
the patch-level 6 version of the public SunOS PPP code.  I am making this
available before the next release due to the rather irritating nature
of the bug and I wanted to provide a timely fix as the new release
isn't quite ready to unleash yet.  The memory allocation scheme is
currently being redesigned for the new release.  


This patch is also available via anonymous FTP as
ftp.quotron.com:pub/ppp-sunos4.1.pl6.mem_leak.patch 

Greg
Keeper of the Public SunOS PPP


*** ppp.c.old	Thu Jan  9 17:16:46 1992
--- ppp.c	Thu Jan  9 17:16:40 1992
***************
*** 839,845 ****
  void io()
  {
      int len, i;
!     u_char *p;
      u_short protocol;
  #ifdef	STREAMS
      struct strbuf str;
--- 839,845 ----
  void io()
  {
      int len, i;
!     u_char *p, *pstart;
      u_short protocol;
  #ifdef	STREAMS
      struct strbuf str;
***************
*** 850,855 ****
--- 850,856 ----
  
      for (;;) {			/* Read all available packets */
  	p = (u_char *) malloc(MTU + DLLHEADERLEN);
+ 	pstart = p;		/* save start of packet */
  #ifdef	STREAMS
  	str.maxlen = MTU+DLLHEADERLEN;
  	str.buf = (caddr_t) p;
***************
*** 859,864 ****
--- 860,866 ----
  		if(errno == EAGAIN || errno == EWOULDBLOCK) {
  			if(debug > 2)
  				perror("ppp: getmsg(fd)");
+ 			free(pstart)
  			return;
  		}
  		perror("ppp: getmsg(fd)");
***************
*** 871,876 ****
--- 873,879 ----
  		if(debug > 2)
  			fprintf(stderr, "ppp: getmsg short return length %d\n",
  				str.len);
+ 		free(pstart);
  		return;
  	}
  		
***************
*** 880,885 ****
--- 883,889 ----
  	    if (errno == EWOULDBLOCK) {
  		if (debug > 2)
  		    perror("ppp: read(fd)");
+ 		free(pstart);
  		return;
  	    }
  	    else {
***************
*** 897,902 ****
--- 901,907 ----
  	if (len < DLLHEADERLEN) {
  	    if (debug)
  		fprintf(stderr, "ppp: input: Received short packet.\n");
+ 	    free(pstart);
  	    return;
  	}
  
***************
*** 909,915 ****
  	 */
  	if (protocol != LCP &&
  	    lcp_fsm[0].state != OPEN) {
! 	    free(p - DLLHEADERLEN);
  	    return;
  	}
  
--- 914,922 ----
  	 */
  	if (protocol != LCP &&
  	    lcp_fsm[0].state != OPEN) {
! 	    if (debug)
! 		fprintf(stderr, "ppp: input: Received non-LCP packet and LCP is not in open state.\n");
! 	    free(pstart);
  	    return;
  	}
  
--
Greg Christy                           Internet:  gmc@quotron.com
Quotron Systems, Inc.
12731 W. Jefferson Blvd., M/S F1-10    Voice: (310) 302-4253
Los Angeles, CA 90066                  FAX:   (310) 302-4499


