
/*
 * Include file for adb scripts to examine kernel data structures.
 *
 * Copyright (C) 1993 Purdue University, All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Purdue University.  The name of the University may not be used
 * to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/systm.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/errno.h>
#include <sys/cred.h>
#include <sys/stat.h>
#include <sys/kmem.h>
#include <sys/ddi.h>
#include <sys/modctl.h>
#ifdef	KSTAT
#include <sys/kstat.h>
#endif
#include <sys/sunddi.h>
#include <sys/dlpi.h>
#include <sys/byteorder.h>

#include <netinet/in.h>		/* For TCP activity tracking */
#include <netinet/in_systm.h>
#include <netinet/ip.h>	
#include <netinet/tcp.h>	

#include "../h/ppp.h"
#include "../h/dpio.h"
#include "../h/dpvar.h"

#define	IP_ETHERCENTRIC
#ifdef	IP_ETHERCENTRIC
/*
 * The Solaris 2.1 IP module likes to request SAPs using ethernet types.
 * This conversion shouldn't be necessary, but it appears to be the case...
 * If anyone knows how to eliminate this kludge, please let me know. --ks
 */
#include <sys/ethernet.h>
#endif
