/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * static char sccsid[] = "@(#)logwtmp.c	5.2 (Berkeley) 9/20/88";
 */

#if !defined(lint) && !defined(SABER)
static char sccsid[] = "@(#)logwtmp.c	5.2 (Berkeley) 9/22/88";
#endif /* not lint && not SABER*/

#include <sys/types.h>
#include <sys/file.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <utmp.h>
#include <string.h>
#include <memory.h>

#ifdef	SOLARIS_1
#define	WTMP_FILE	"/var/adm/wtmp"
#endif

static int fd;

logwtmp(line, name, host)
	char *line, *name, *host;
{
	struct utmp ut;
	struct stat buf;
	time_t time();
	char *strncpy();

	if (!fd && (fd = open(WTMP_FILE, O_WRONLY|O_APPEND, 0)) < 0)
		return;
	if (!fstat(fd, &buf)) {
#ifdef	SOLARIS_1
		(void)strncpy(ut.ut_line, line, sizeof(ut.ut_line));
		(void)strncpy(ut.ut_name, name, sizeof(ut.ut_name));
		(void)strncpy(ut.ut_host, host, sizeof(ut.ut_host));
		(void)time(&ut.ut_time);
#else
		/*
		 * Is this stuff documented anywhere?  This is close
		 * but I'm not sure about ut_type, ut_id, and ut_exit.
		 */
		memcpy((caddr_t)&ut, 0, sizeof(ut));
		(void)strncpy(ut.ut_user, name, sizeof(ut.ut_name));
		(void)strncpy(ut.ut_line, line, sizeof(ut.ut_line));
		ut.ut_pid = getpid();
		ut.ut_type = USER_PROCESS;
		time(&ut.ut_time);
		(void)time(&ut.ut_time);
#endif
		if (write(fd, (char *)&ut, sizeof(struct utmp)) !=
		    sizeof(struct utmp))
			(void)ftruncate(fd, buf.st_size);
	}
}
