

     "archie - An Electronic Directory Service for the Internet"




                                               Peter Deutsch,
                                               Computing Centre,
                                               McGill University.

                                       email:  peterd@cc.mcgill.ca


Introduction
-------------

Few other areas in the field of computer science hold out
such promise for significant performance gains in the
coming years as the field of computer networking.
While even a single computer allows the user to access and
process information faster and more accurately than ever
before, joining large numbers of such computers together
with the communications tools needed for users to easily
share information and resources promises the prospect of a
true "electronic highway" for information exchange unlike
anything seen to date.

A principal requirement for the creation of this brave new
world of networked information was the creation of a
standard set of protocols and communication mechanisms to
allow users on disparate networks to share information.
Such mechanisms have allowed the creation of the Internet.
a global network of networks that now span the globe,
connecting millions of users on hundreds of thousands of
computers.

The Internet now connects universities, colleges and other
centres of learning with commercial research and
development groups throughout the world. It serves as both
a live testbed for on-going networking research and a
daily communications tool for thousands of users in fields
far removed from networking and computer science. One
recent survey estimates that the Internet currently has
over 535,000 attached hosts in over 30 countries, with a
user community estimated at over three million people.

The existence of this global information service has
in turn spurred the development of mechanisms for
locating and exchanging information. Distributed file
systems, on-line file archiving mechanisms, electronic mail
and bulletin boards and expert systems for locating
and accessing technical expertise are all services that
exist now on the Internet. 

The huge size (and continued rapid growth) of the Internet
offer a particular challenge to systems designers and
service providers in this new environment. Before a user
can effectively exploit any of the services offered by the
Internet community the user must be aware of both the
existence of the service and the host or hosts on
which it is available. Adequately addressing this "resource
discovery problem" is a central challenge for both service
providers and users wishing to capitalize on the
possibilities of the Internet.
	

What is the archie service?
----------------------------

The archie service is a collection of resource discovery
tools that together provide an electronic directory
service for locating information in an Internet
environment. Originally created to track the contents of
anonymous ftp archive sites, the archie service is now
being expanded to include a variety of other on-line
directories and resource listings.

Users can access an archie server either through
interactive sessions (provided they have a direct Internet
connection) or through queries sent via electronic mail
messages (provided they can at least gateway electronic
mail messages onto the Internet).

Interactive access to archie may be through a conventional
telnet session to a machine running an archie server or
through a program that has been integrated into a larger
system, such as the Prospero network distributed file
system. Additional stand-alone clients are now being
tested and are available over the network.


Why use archie?
---------------

The existence of the archie service allow those seeking
information maintained by an archie server to limit their
network search to a set of questions to a known server.
The responses in turn offer pointers to specific Internet
service providers. Once the existence and location of
specific information or services has been determined using
archie, traditional networking tools can be used for final
access.

Programs have already been created that integrate an
archie client with the ftp file transfer program or into
larger information access services. This allows a user to
first locate and then access information from archie sites
using a single program.


The archie Service Today
--------------------------

Currently, archie tracks the contents of over 800
anonymous ftp archive sites containing some 1,000,000
files throughout the Internet. Collectively, these files
represent well over 50 Gigabytes (50,000,000,000 bytes) of
information, with additional information being added daily.
Anonymous ftp archive sites offer software, data and other
information that can be copied and used without charge by
anyone with connection to the Internet.

The archie server automatically updates the listing
information from each site about once a month, ensuring
users that the information they receive is reasonably
timely, without imposing an undue load on the archive
sites or network bandwidth.


The "whatis" database
-----------------------

In addition to offering access to anonymous ftp listings,
archie also permits access to the "whatis"
description database. This database is a collection of
descriptions that includes the name and a brief synopsis
for over 3,500 public domain software packages, datasets
and informational documents located on the Internet.

Additional "whatis" databases are scheduled to be added in
the coming months. Planned offerings include listings for
the names and locations of on-line library catalogue
programs, the names of publicly accessible electronic
mailing lists and compilations of Frequently Asked
Questions lists and archive sites for the most popular
Usenet "newsgroups" or bulletin boards. Suggestions for
additional descriptions or locations databases are
welcomed and should be sent to the archie developers at
"archie-l@archie.mcgill.ca".

Service providers are also encouraged to send in details of
their offerings to the archie maintainers so that the
server tracking software can be configured to
automatically perform updates when site information
changes. An automatic registration mechanism has also been
proposed that would allow service providers to make their
service available without human intervention. This feature
is expected to be integrated into an upcoming release.


Using archie
-------------

Users with direct Internet connectivity can try out an
interactive archie server using the basic "telnet" command
(available at most sites). To use, telnet to the host
"archie.mcgill.ca" [132.206.2.3] and login as user
"archie" (there is no password needed). A banner message
giving latest developments and information on the archie
project will be displayed and then the command prompt will
appear. First-time users should try the "help" command to
get started.

Users with only email connectivity to the Internet should
send a message to "archie@archie.mcgill.ca", with the
single word "help" in either the subject line or body of
the message. You should receive back an email message
explaining how to use the email archie server, along with
details of an email-based ftp server operated by Digital
Equipment Corporation that will perform ftp transfers
through email requests.

Demo archie clients are stored on archie.mcgill.ca in the
subdirectory "archie/clients" and may be obtained using
anonymous ftp. There are several such clients and others are
currently being tested. Additional work is planned in
this area in the coming months and details will be announced
in the archie banner message displayed on login.

Documentation for the archie system is still limited, but
what there is is also available for anonymous ftp from the
same host under the directory "archie/pub".


Miscellaneous Information
--------------------------

The archie service began as a project for students and
volunteer staff at the McGill University School of Computer
Science. It is now offered as a network resource by a
number of sites. At the time this article was prepared,
archie servers are being operated as "archie.mcgill.ca"
(by McGill University in Montreal, Canada),
"archie.funet.fi" (by FUnet in Finland) and "archie.au"
(by AARnet in Australia). The source to the archie project
has been distributed to a number of U.S. sites and
additional North American servers are expected to be
operational soon.

The archie project continues to grow in part because of
the feedback and response from users. Suggestions for
improvements and additional features are especially
welcome. Please let us know what you think...


Contacting the archie people
-----------------------------

Email addresses:

Please send comments, suggestions and bug reports to
"archie-l@archie.mcgill.ca". This address reaches the
implementors of archie.

There is also the "archie-people@archie.mcgill.ca" mailing
list. This list is for people interested in developments
and progress of the archie project and is open to all who
wish to subscribe.


Surface mail address:

	UNIX Support Group,
	Computing Centre,
	McGill University,
	room 200, Burnside Hall,
	805 Sherbrooke Street West,
	Montreal, Quebec
	CANADA		H3A 2K6


Phone: (514) 398-3709

